#include <bits/stdc++.h>
#define pb push_back
#define dout if(dbg) cout

using namespace std;
typedef long long ll;

bool dbg = 0;

ll a[500001];

ll brK[65] = {0}, minDist[65] = {0}; // brKeceva
ll desnoKecevi[65];
ll najblizi[500001][64]; // za svaki br, najblizi za setovanje b-tog bita (mzd mogu oba)

typedef long double ld;
ll ls[65];

vector<ll> minimumi;

ll mDist(ll a, ll bit, ll ind)
{
    ll prviVeci = a;
    prviVeci |= ls[bit];
    if(bit != 0)
        prviVeci -= (a & desnoKecevi[bit-1]);

    ll dist1 = abs(a - prviVeci);
    ll prviManji = a;
    if(ls[bit] > a)
    {
        najblizi[ind][bit] = prviVeci;
        return dist1;
    }
    if(bit != 0)
        prviManji -= (a & desnoKecevi[bit-1]);
    prviManji--;

    ll dist2 = a - prviManji;
    if(dist1 == dist2)
    {
        najblizi[ind][bit] = prviVeci;
        return dist1;
    }
    else if(dist1 > dist2)
    {
        najblizi[ind][bit] = prviManji;
        return dist2;
    }
    else
    {
        najblizi[ind][bit] = prviVeci;
        return dist1;
    }
}

int main()
{
    //cout << (ll)(((ll)1 << 64) - 1);
    if(!dbg)
    {
        ios::sync_with_stdio(false);
        cin.tie(0);
    }
    ls[0] = 1;
    ll maksBit = 2;
    for(ll i = 1; i < 64; i++)
        ls[i] = 2*ls[i-1];
    desnoKecevi[0] = 1;
    for(ll i = 1; i < 64; i++)
        desnoKecevi[i] = (ls[i] + desnoKecevi[i-1]);

    ll n;
    cin >> n;

    for(ll i = 0; i < n; i++)
    {
        cin >> a[i];
        maksBit = max(maksBit, (ll)log2(a[i]) + 1);
    }
    if(maksBit > 62) maksBit = 62;

    bool imaAnd = false, imaXor = false, imaAndBez0 = false;
    for(ll b = 0; b <= maksBit; b++)
    {
        for(ll i = 0; i < n; i++)
        {
            najblizi[i][b] = 666666;
            bool bit = ((a[i] & ls[b]));
            brK[b] += bit;
            if(!bit) minDist[b] += mDist(a[i], b, i);
        }
        imaAnd |= (brK[b] == n), imaXor |= (brK[b]&1);
        if(brK[b] == n && b != 0) imaAndBez0 = true;
        if(imaAnd && imaXor)
        {
            cout << 0;
            return 0;
        }
    }

    if(imaAndBez0)
    {
        cout << 1;
        return 0;
    }

    for(int i = 0; i <= maksBit; i++)
        if(minDist[i] < 0) minDist[i] = (((ll)1 << 63) - 1);

    ll minAnd = (ll)(((ll)1 << 63)-1);

    for(ll b = 0; b <= maksBit; b++)
        minAnd = min(minAnd, minDist[b]);

    for(ll b = 0; b <= maksBit; b++)
        if(minDist[b] == minAnd) minimumi.pb(b);

    if(minimumi.size() > 1 && n >= 100000)
    {
        cout << minAnd+1;
        return 0;
    }
    for(ll ii = minimumi.size() - 1; ii >= 0; ii--)
    {
        ll b = minimumi[ii];
        for(ll bb = maksBit; bb >= 0; bb--)
        {
            ll brK;
            for(ll i = 0; i < n; i++)
            {
                if(najblizi[i][b] != 666666)
                {
                    ll prviManji = a[i];
                    if(ls[b] > a[i]) // nema prvog manjeg
                    {
                        bool bit = (najblizi[i][b] & ls[bb]);
                        brK += bit;
                    }
                    else
                    {
                        if(b != 0) prviManji -= (a[i] & desnoKecevi[b-1]);
                        prviManji--;

                        if((a[i] - prviManji) == (najblizi[i][b] - a[i]))
                        {
                            cout << minAnd;
                            return 0;
                        }
                        else
                        {
                            bool bit = (najblizi[i][b] & ls[bb]);
                            brK += bit;
                        }
                    }
                }
                else
                {
                    bool bit = (a[i] & ls[bb]);
                    brK += bit;
                }
            }
            if(brK%2 == 1)
            {
                cout << minAnd;
                return 0;
            }
        }
    }

    if(minimumi.size() == 1 && minimumi[0] == 0)
    {
        cout << minAnd + 2;
        return 0;
    }
    cout << minAnd + 1;
    return 0;
}